//	BulletExplodeDeath.cpp - Class for bullets to explode when they die.
//  ----------------------------------------------------------------------------
//	This file is part of 'NiallsAVLib', base code for any kind of audiovisual
//	apps.
//	Copyright (C) 2012  Niall Moody
//	
//	This program is free software: you can redistribute it and/or modify
//	it under the terms of the GNU General Public License as published by
//	the Free Software Foundation, either version 3 of the License, or
//	(at your option) any later version.
//
//	This program is distributed in the hope that it will be useful,
//	but WITHOUT ANY WARRANTY; without even the implied warranty of
//	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//	GNU General Public License for more details.
//
//	You should have received a copy of the GNU General Public License
//	along with this program.  If not, see <http://www.gnu.org/licenses/>.
//	----------------------------------------------------------------------------

#include "BulletExplodeDeath.h"
#include "GamePlayState.h"
#include "MiscHelper.h"
#include "Bullet.h"
#include "Random.h"

//------------------------------------------------------------------------------
BulletDeathCreator<BulletExplodeDeath> BulletExplodeDeath::creator;

//------------------------------------------------------------------------------
BulletExplodeDeath::BulletExplodeDeath()
{

}

//------------------------------------------------------------------------------
BulletExplodeDeath::~BulletExplodeDeath()
{

}

//------------------------------------------------------------------------------
void BulletExplodeDeath::bulletDeath(Bullet& bullet, GamePlayState& state)
{
	float angle;
	unsigned int i;
	TwoFloats tempPos;
	TwoFloats tempDir;
	const TwoFloats origin;
	const TwoFloats startPos(bullet.getPosition()-(bullet.getDirection()*12.0f));

	/*if(bullet.getIncorporeal())
		return;*/
	if(bullet.getLifespan() < 16.0f)
		return;

	angle = origin.getAngle(bullet.getDirection());
	tempDir.x = -sinf(angle);
	tempDir.y = cosf(angle);
	for(i=0;i<8;++i)
	{
		state.firePlainBullet(startPos,
							  tempDir,
							  bullet.getColour(),
							  bullet.getParent());

		angle += NIALL_PI/8.0f;
		tempDir.x = -sinf(angle);
		tempDir.y = cosf(angle);
	}
}

//------------------------------------------------------------------------------
//------------------------------------------------------------------------------
void BulletExplodeDeathCreator::apply(GamePlayState& state)
{
	state.getBulletCreator().addDeathModifier(&BulletExplodeDeath::creator);
}
